#!/bin/sh
#
# pilot		fish soup
#
# chkconfig: 2345 60 60
# description: fish soup
# processname: autopilot

# Source function library.
. /etc/rc.d/init.d/functions

# Source networking configuration.
. /etc/sysconfig/network

# Check that networking is up.
[ ${NETWORKING} = "no" ] && exit 0

RETVAL=0

# See how we were called.
case "$1" in
  start)
        # Start daemons.
        echo -n "Starting autopilot: "
#        daemon /software/bin/autopilot -n 2 -c /software/scripts/do_sync -p /dev/pilot
#        daemon /software/bin/autopilot -n 2 -c /software/scripts/do_sync_tty1 -p /dev/ttyS1 
	/software/bin/ap-ident -m "pppd noauth nodetach debug passive crtscts :palm-circe proxyarp /dev/ttyS1 " -h "pi-nredir /dev/ttyS1" -n 2 -t 6 -p /dev/ttyS1 

	RETVAL=$?
        echo
        [ $RETVAL -eq 0 ] && touch /var/lock/subsys/autopilot
        ;;
  stop)
        # Stop daemons.
        echo -n "Shutting down autopilot: "
	killall ap-ident
#	killproc autopilot
#	killall autopilot
	RETVAL=$?
        echo
        [ $RETVAL -eq 0 ] && rm -f /var/lock/subsys/autopilot
        ;;
  status)
	status autopilot
	RETVAL=$?
	;;
  restart|reload)
	$0 stop
	$0 start
	RETVAL=$?
	;;
  *)
        echo "Usage: autopilot {start|stop|restart|reload|status}"
        exit 1
esac

exit $RETVAL
