/*
 * guts.h:
 *
 * Copyright (c) 2001 James McKenzie <james@fishsoup.dhs.org>,
 * All rights reserved.
 *
 */

/*
 * $Id: guts.h,v 1.2 2001/12/04 14:51:24 root Exp root $
 */

/*
 * $Log: guts.h,v $
 * Revision 1.2  2001/12/04 14:51:24  root
 * #
 *
 * Revision 1.1  2001/11/23 13:14:23  root
 * #
 *
 */

#ifndef __GUTS_H__
#define __GUTS_H__

#include <stdio.h>
#include <fcntl.h>
#include <sys/types.h>
#include <dirent.h>
#include <sys/param.h>
#include <stdarg.h>
#include <strings.h>
#include <string.h>
#include <sys/stat.h>
#include <malloc.h>
#include <unistd.h>

#include "db.h"

#include "pi-source.h"
#include "pi-socket.h"
#include "pi-dlp.h"
#include "pi-file.h"
#include "pi-header.h"


typedef struct Palmdb_struct {
  char name[34];
#ifdef QUICKSCANCODE
  char type[5];
  char creator[5];
#else
  unsigned long type;
  unsigned long creator;
#endif
  int serial;
} *Palmdb;
#define PALMDB_SIZE (sizeof(struct Palmdb_struct))

DB *files_db;
DB *notfound_db;
DB *ovwr_db;

static int install_serial = 0;
static int forced = 0;
static int preserved = 0;

#define DBERROR(d,o,r,fmt...) my_dberror(d,#d,#o,r,__FILE__,__LINE__,fmt)
#define CRASH_AND_BURN(fmt...) crash_and_burn(__FILE__,__LINE__,fmt)

void
my_dberror(DB * db, char *dbn, char *op, int ret, char *file, int line,
           char *fmt, ...);

void crash_and_burn(char *file, int line, char *fmt, ...);

Palmdb file_to_palmdb(char *file);


#endif                          /* __GUTS_H__ */
