/*
 * pilot-restarter.c:
 *
 * Copyright (c) 2001 James McKenzie <james@fishsoup.dhs.org>,
 * All rights reserved.
 *
 */

static char rcsid[] =
    "$Id: pilot-restarter.c,v 1.3 2001/12/04 14:51:24 root Exp root $";

/*
 * $Log: pilot-restarter.c,v $
 * Revision 1.3  2001/12/04 14:51:24  root
 * #
 *
 * Revision 1.2  2001/11/23 13:15:19  root
 * #
 *
 * Revision 1.1  2001/11/23 13:14:23  root
 * #
 *
 */

#include "guts.h"


void do_install(char *from)
{
  FILE *in, *out;
  char buf[1024], nme[80];
  int red;

  {
    Palmdb d = file_to_palmdb(from);
    char *ptr = nme;

    if (!d) 
      CRASH_AND_BURN("Couldn't infoize %s\n", from);

    strcpy(nme, d->name);
    free(d);

    while (*ptr) {
      if (!isalnum(*ptr))
        *ptr = '_';
      ptr++;
    }
  }


  in = fopen(from, "r");
  if (!in)
    CRASH_AND_BURN("Couldn't open %s\n", from);
  sprintf(buf, "restart/restarter-%s-%06d.pdb", nme, install_serial++);
  out = fopen(buf, "w");
  if (!out)
    CRASH_AND_BURN("Couldn't open %s\n", buf);

#ifdef DEBUG
  printf("%s->%s\n", from, buf);
#endif

  while ((red = fread(buf, 1, sizeof(buf), in)) > 0) {
    fwrite(buf, 1, red, out);
  }
  fclose(in);
  fclose(out);

}

void walk_lost(void)
{
  DBC *c;
  DBT key = { 0 }, data = {
  0};
  int ret;

  if (ret = notfound_db->cursor(notfound_db, NULL, &c, 0)) {
    DBERROR(notfound_db, cursor, ret, NULL);
    return;
  }

  while (1) {
    ret = c->c_get(c, &key, &data, DB_NEXT);
    if (ret == DB_NOTFOUND)
      break;
    if (ret)
      DBERROR(notfound_db, c_get, ret, NULL);
    do_install(key.data);

    printf("Preserving %s\n", key.data);
    preserved++;
  }

  c->c_close(c);



}

#include "guts.c"
