/*
 * AutoSync/PowerLib.c:
 *
 * Copyright (c) 2001 James McKenzie <james@fishsoup.dhs.org>,
 * All rights reserved.
 *
 */

/* NO GLOBAL DATA */

/*
 * static char rcsid[] = "$Id: PowerLib.c,v 1.1 2001/09/14 11:06:28 root Exp root $";
 */

/*
 * $Log: PowerLib.c,v $
 * Revision 1.1  2001/09/14 11:06:28  root
 * #
 *
 */

#include <SystemMgr.h>

#define GAUSSLIB_TRAP(trapno)

#include "PowerLib.h"

Err
start(UInt16 refnum,SysLibTblEntryPtr entryP) { 
   extern void *jmptable (); 
   entryP->dispatchTblP = (void *) jmptable; 
   entryP->globalsP = NULL; 
   return 0; 
} 

/* The globals structure for this library */
typedef struct
{
  UInt32 refcount;
  UInt32 boottime;
}
PowerLib_globals;

Err
PowerLibOpen (UInt16 refnum)
{
  SysLibTblEntryPtr entryP = SysLibTblEntry (refnum);
  PowerLib_globals *gl = (PowerLib_globals *) entryP->globalsP;

  if (!gl)
    {
    gl = entryP->globalsP = MemPtrNew (sizeof (PowerLib_globals)); 
     MemPtrSetOwner (gl, 0); 
     gl->refcount = 0; 
     gl->boottime=-1;
    }

  gl->refcount++;

  return 0;
}

Err
PowerLibClose (UInt16 refnum, UInt16 *numappsP)
{
  SysLibTblEntryPtr entryP = SysLibTblEntry (refnum);
  PowerLib_globals *gl = (PowerLib_globals *) entryP->globalsP;
  if (!gl)
      return 1;

  *numappsP = --gl->refcount;
  if (*numappsP == 0)
    {
      MemChunkFree (entryP->globalsP);
      entryP->globalsP = NULL;
    }

  return 0;
}



Err
nothing (UInt16 refnum)
{
  return 0;
}

Err
PowerLibWake (UInt16 refnum)
{
  SysLibTblEntryPtr entryP = SysLibTblEntry (refnum);
  PowerLib_globals *gl = (PowerLib_globals *) entryP->globalsP;
  if (!gl)
    return 1;
  gl->boottime = TimGetTicks ();
  return 0;
}

Err PowerLibBootTime(UInt16 refnum,UInt32 *bt) 
{
  SysLibTblEntryPtr entryP = SysLibTblEntry (refnum);
  PowerLib_globals *gl = (PowerLib_globals *) entryP->globalsP;
  if (!gl)
    return 1;
  *bt=gl->boottime;
  return 0;
}
