/*
 * AutoSync/main.c:
 *
 * Copyright (c) 2001 James McKenzie <james@fishsoup.dhs.org>,
 * All rights reserved.
 *
 */

static char rcsid[] = "$Id: main.c,v 1.5 2001/09/14 11:06:28 root Exp root $";

/*
 * $Log: main.c,v $
 * Revision 1.5  2001/09/14 11:06:28  root
 * #
 *
 * Revision 1.4  2001/09/14 11:05:00  root
 * #
 *
 * Revision 1.3  2001/09/14 09:57:30  root
 * #
 *
 */

#include "project.h"

        void            HwrSleep(Boolean untilReset, Boolean emergency)
                                                        SYS_TRAP(sysTrapHwrSleep);

#define SerialLibraryName "Serial Library"
#define PowerLibraryName "PowerLib Library"

#define MAXBOOTTIME (sysTicksPerSecond*4)
#define SYNCINTERVAL (30*60)

/* Ok this is foul/fowl we have a library which we forget to
   un-install this ensures that that it gets wake event which
   we can use to determine if the alarm we received caused the
   device to power up, if it did then we can proceed to checking
   for CTS, and then do an app switch to sync if req'd, otherwise
   if we didn't power up we just re-schedule the alarm */

#include "../common.c"
UInt get_pwrlib (void)
{
  Err err;
  UInt PowerLibrary;
  err = SysLibFind (PowerLibraryName, &PowerLibrary);
  if (err)
    err = SysLibLoad ('libr', 'PwSL', &PowerLibrary);
  if (err)
    return -1;
  err = PowerLibOpen (PowerLibrary);
  return PowerLibrary;
}


#define DEFAULT_PORT 0
int
get_cts ()
{
  Err err;
  UInt SerialLibrary;
  Boolean cts, dsr;
  SysLibFind (SerialLibraryName, &SerialLibrary);
  err = SerOpen (SerialLibrary, DEFAULT_PORT, 9600);
  SerGetStatus (SerialLibrary, &cts, &dsr);
  SerClose (SerialLibrary);
  return cts ? 1 : 0;
}

char buf[1024];
DWord normal_launch (void)
{
  UInt pwr = get_pwrlib ();
  int i;
  FrmCustomAlert (Done_Alert, buf, NULL, NULL);
}

void DimScreen(void)
{
UInt32 hw;

FtrGet (sysFtrCreator, sysFtrNumHwrMiscFlagsExt, &hw);

if (hw & hwrMiscFlagExtHasSWBright) 
SysLCDBrightness(true,0);
}

void
alarm (void)
{
  UInt pwr = get_pwrlib ();
  UInt32 t, b;
  int i;
  t = TimGetTicks ();
  PowerLibBootTime (pwr, &b);
  t -= b;
  StrPrintF (buf, "Ticks %ld soup", t);
  if ((t < 0) || (t > MAXBOOTTIME))
    return;
  i = get_cts ();
  if (!i)
    {
      HwrSleep (false, false);
      return;
    }
  StopNet ();
  DoSwitch (eSerIrUseCable);
  DimScreen();
  StartSyncApplication ();
}

void
set_alarm (void)
{
  UInt16 cardNo;
  LocalID dbID;
  DmSearchStateType searchInfo;
  UInt32 alarmTime, ref;
  ref = 0;
  alarmTime = TimGetSeconds () + SYNCINTERVAL;
  DmGetNextDatabaseByTypeCreator (true, &searchInfo, sysFileTApplication,
                                  'asyc', true, &cardNo, &dbID);
  AlmSetAlarm (cardNo, dbID, ref, alarmTime, true);
}

DWord PilotMain (Word cmd, Ptr cmdPBP, Word launchFlags)
{
  switch (cmd)
    {
    case sysAppLaunchCmdAlarmTriggered:
      return 0;
    case sysAppLaunchCmdDisplayAlarm:
      set_alarm ();
      alarm ();
      return 0;
    case sysAppLaunchCmdSystemReset:
      (void) get_pwrlib ();
      set_alarm ();
      return 0;
    case sysAppLaunchCmdTimeChange:
      set_alarm ();
      return 0;
    case sysAppLaunchCmdSyncNotify:
      set_alarm ();

      /* Power down? */
      return 0;
    case 0:
      set_alarm ();
      normal_launch ();
      return 0;
    default:
      return 0;
    }
}
