/*
 * common.c:
 *
 * Copyright (c) 2001 James McKenzie <james@fishsoup.dhs.org>,
 * All rights reserved.
 *
 */

/* static char rcsid[] =
 *  "$Id: common.c,v 1.3 2001/09/14 11:05:01 root Exp root $";
 */

/*
 * $Log: common.c,v $
 * Revision 1.3  2001/09/14 11:05:01  root
 * #
 *
 * Revision 1.2  2001/09/14 09:57:31  root
 * #
 *
 */

/*
	Program to change Serial/IR settings to "Cradle" and start a local HotSync
	Should be installed to be launched when the HotSync-button
	on the craddle is pressed.
	
	(C)1999 Anders Gustafsson - andersg@funcform.se

	This program and sourcecode may	be freely distributed as long as this
	text isn't removed and any modifications to the program are distributed free.

	The author is NOT responsible for any damages caused by this program.

	v0.2 (990627 13:00) Fully functional version
	v0.1 (990627 02:00) First version


	TODO: reset Serial/IR settings to IR when HotSync is completed

*/

#include "SerIR.h"
static void
StartSyncApplication (void)
{
  LocalID mDBID;
  UInt mCardNo;
  DmSearchStateType mSearchState;
  DmGetNextDatabaseByTypeCreator (true, &mSearchState, sysFileTApplication,
                                  sysFileCSync, true, &mCardNo, &mDBID);
  SysUIAppSwitch (mCardNo, mDBID, sysAppLaunchCmdSyncRequestLocal, NULL);
}

#if 0
static int
GetSwitch ()
{
  Err err;
  int i;
  UInt refNum, size;
  SerIrPanelPreferencesType mSIRprefs;
  err = SysLibFind ("SerIrCOMM Lib", &refNum);
  if (!err)
    {
      SerControl (refNum, serIrCommCtlSysLibFindPatchEnable, (VoidPtr) 0,
                  (WordPtr) 0);
      size = sizeof (mSIRprefs);
      PrefGetAppPreferences (serIrPanelCreator, serIrPanelPrefsID,
                             &mSIRprefs, &size, serIrPanelPrefsSaved);
      return mSIRprefs.serIrSelection;
    }
  return -1;
}
#endif
static void
DoSwitch (SerIrEnum which)
{
  Err err;
  UInt refNum;
  SerIrPanelPreferencesType mSIRprefs;
  err = SysLibFind ("SerIrCOMM Lib", &refNum);
  if (!err)
    {
      SerControl (refNum, serIrCommCtlSysLibFindPatchEnable, (VoidPtr) which,
                  (WordPtr) 0);
      mSIRprefs.serIrSelection = which;
      PrefSetAppPreferences (serIrPanelCreator, serIrPanelPrefsID,
                             serIrPanelPrefsVersionNum, &mSIRprefs,
                             sizeof (SerIrPanelPreferencesType),
                             serIrPanelPrefsSaved);}
}
static void
StartNet (void)
{
  UInt16 iferrs, AppNetRefnum;
  Err err;
  err = SysLibFind ("Net.lib", &AppNetRefnum);
  if (err)
    return;
  err = NetLibOpen (AppNetRefnum, &iferrs);
  if (err)
    return;
  if (iferrs)
    {
      NetLibClose (AppNetRefnum, true);
      return;
    }
  NetLibClose (AppNetRefnum, false);
}
static void
StopNet (void)
{
  UInt16 AppNetRefnum, open;
  Err err;
  err = SysLibFind ("Net.lib", &AppNetRefnum);
  if (err)
    return;
  open = 0;
  err = NetLibOpenCount (AppNetRefnum, &open);
  while (open > 0)
    {
      NetLibClose (AppNetRefnum, false);
      err = NetLibOpenCount (AppNetRefnum, &open);
    }
  NetLibFinishCloseWait (AppNetRefnum);
}
